-------------------------------------------------------------------------------
--
-- | 
-- Module      :  Language.XMLSchema.Syntax
-- Copyright   :  (c) Ricardo Vilaça, 2005
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- This module defines the Abstract Syntax Tree (AST) for the
-- XML Schema language, accondingly with the ISO standard. This AST has generated by 
-- the DtdToHaskell tool from HaXml using a equivalent changed version of the DTD that defines
-- XML Schema form w3c
-- 
-------------------------------------------------------------------------------

module Language.XMLSchema.Syntax where

import Text.XML.HaXml.OneOfN
import Text.XML.HaXml.Xml2Haskell

{-Type decls-}

data Xs'simpleType = Xs'simpleType Xs'simpleType_Attrs
				   (Maybe (Xs'annotation)) (OneOf3 Xs'restriction Xs'list Xs'union)
		   deriving (Eq,Show)
data Xs'simpleType_Attrs = Xs'simpleType_Attrs
    { xs'simpleTypeName :: (Maybe String)
    , xs'simpleTypeId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'restriction = Xs'restriction Xs'restriction_Attrs
				     (Maybe (Xs'annotation))
				     (OneOf2 ((Maybe (OneOf4 Xs'all Xs'choice Xs'sequence Xs'group))) ((Maybe (Xs'simpleType)),[(OneOf13 (OneOf2 Xs'minInclusive Xs'minExclusive) (OneOf2 Xs'maxInclusive Xs'maxExclusive) Xs'precision Xs'scale Xs'pattern Xs'enumeration Xs'whiteSpace Xs'length Xs'maxLength Xs'minLength Xs'encoding Xs'period Xs'duration)]))
				     (([(OneOf2 Xs'attribute Xs'attributeGroup)],(Maybe (Xs'anyAttribute))))
		    deriving (Eq,Show)
data Xs'restriction_Attrs = Xs'restriction_Attrs
    { xs'restrictionBase :: (Maybe String)
    , xs'restrictionId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'list = Xs'list Xs'list_Attrs (Maybe Xs'annotation) 
            (Maybe Xs'simpleType)
          deriving (Eq,Show)
data Xs'list_Attrs = Xs'list_Attrs
    { xs'listItemType :: (Maybe String)
    , xs'listId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'union = Xs'union Xs'union_Attrs (Maybe (Xs'annotation))
			 [(Xs'simpleType)]
	      deriving (Eq,Show)
data Xs'union_Attrs = Xs'union_Attrs
    { xs'unionId :: (Maybe String)
    , xs'unionMemberTypes :: (Maybe String)
    } deriving (Eq,Show)
data Xs'maxExclusive = Xs'maxExclusive Xs'maxExclusive_Attrs
				       (Maybe Xs'annotation)
		     deriving (Eq,Show)
data Xs'maxExclusive_Attrs = Xs'maxExclusive_Attrs
    { xs'maxExclusiveValue :: String
    , xs'maxExclusiveFixed :: (Maybe Xs'maxExclusive_fixed)
    } deriving (Eq,Show)
data Xs'maxExclusive_fixed = Xs'maxExclusive_fixed_true  | 
			     Xs'maxExclusive_fixed_false
			   deriving (Eq,Show)
data Xs'minExclusive = Xs'minExclusive Xs'minExclusive_Attrs
				       (Maybe Xs'annotation)
		     deriving (Eq,Show)
data Xs'minExclusive_Attrs = Xs'minExclusive_Attrs
    { xs'minExclusiveValue :: String
    , xs'minExclusiveFixed :: (Maybe Xs'minExclusive_fixed)
    } deriving (Eq,Show)
data Xs'minExclusive_fixed = Xs'minExclusive_fixed_true  | 
			     Xs'minExclusive_fixed_false
			   deriving (Eq,Show)
data Xs'maxInclusive = Xs'maxInclusive Xs'maxInclusive_Attrs
				       (Maybe Xs'annotation)
		     deriving (Eq,Show)
data Xs'maxInclusive_Attrs = Xs'maxInclusive_Attrs
    { xs'maxInclusiveValue :: String
    , xs'maxInclusiveFixed :: (Maybe Xs'maxInclusive_fixed)
    } deriving (Eq,Show)
data Xs'maxInclusive_fixed = Xs'maxInclusive_fixed_true  | 
			     Xs'maxInclusive_fixed_false
			   deriving (Eq,Show)
data Xs'minInclusive = Xs'minInclusive Xs'minInclusive_Attrs
				       (Maybe Xs'annotation)
		     deriving (Eq,Show)
data Xs'minInclusive_Attrs = Xs'minInclusive_Attrs
    { xs'minInclusiveValue :: String
    , xs'minInclusiveFixed :: (Maybe Xs'minInclusive_fixed)
    } deriving (Eq,Show)
data Xs'minInclusive_fixed = Xs'minInclusive_fixed_true  | 
			     Xs'minInclusive_fixed_false
			   deriving (Eq,Show)
data Xs'precision = Xs'precision Xs'precision_Attrs
				 (Maybe Xs'annotation)
		  deriving (Eq,Show)
data Xs'precision_Attrs = Xs'precision_Attrs
    { xs'precisionValue :: String
    , xs'precisionFixed :: (Maybe Xs'precision_fixed)
    } deriving (Eq,Show)
data Xs'precision_fixed = Xs'precision_fixed_true  | 
			  Xs'precision_fixed_false
			deriving (Eq,Show)
data Xs'scale = Xs'scale Xs'scale_Attrs (Maybe Xs'annotation)
	      deriving (Eq,Show)
data Xs'scale_Attrs = Xs'scale_Attrs
    { xs'scaleValue :: String
    , xs'scaleFixed :: (Maybe Xs'scale_fixed)
    } deriving (Eq,Show)
data Xs'scale_fixed = Xs'scale_fixed_true  |  Xs'scale_fixed_false
		    deriving (Eq,Show)
data Xs'length = Xs'length Xs'length_Attrs (Maybe Xs'annotation)
	       deriving (Eq,Show)
data Xs'length_Attrs = Xs'length_Attrs
    { xs'lengthValue :: String
    , xs'lengthFixed :: (Maybe Xs'length_fixed)
    } deriving (Eq,Show)
data Xs'length_fixed = Xs'length_fixed_true  | 
		       Xs'length_fixed_false
		     deriving (Eq,Show)
data Xs'minLength = Xs'minLength Xs'minLength_Attrs
				 (Maybe Xs'annotation)
		  deriving (Eq,Show)
data Xs'minLength_Attrs = Xs'minLength_Attrs
    { xs'minLengthValue :: String
    , xs'minLengthFixed :: (Maybe Xs'minLength_fixed)
    } deriving (Eq,Show)
data Xs'minLength_fixed = Xs'minLength_fixed_true  | 
			  Xs'minLength_fixed_false
			deriving (Eq,Show)
data Xs'maxLength = Xs'maxLength Xs'maxLength_Attrs
				 (Maybe Xs'annotation)
		  deriving (Eq,Show)
data Xs'maxLength_Attrs = Xs'maxLength_Attrs
    { xs'maxLengthValue :: String
    , xs'maxLengthFixed :: (Maybe Xs'maxLength_fixed)
    } deriving (Eq,Show)
data Xs'maxLength_fixed = Xs'maxLength_fixed_true  | 
			  Xs'maxLength_fixed_false
			deriving (Eq,Show)
data Xs'enumeration = Xs'enumeration Xs'enumeration_Attrs
				     (Maybe Xs'annotation)
		    deriving (Eq,Show)
data Xs'enumeration_Attrs = Xs'enumeration_Attrs
    { xs'enumerationValue :: String
    } deriving (Eq,Show)
data Xs'whiteSpace = Xs'whiteSpace Xs'whiteSpace_Attrs
				   (Maybe Xs'annotation)
		   deriving (Eq,Show)
data Xs'whiteSpace_Attrs = Xs'whiteSpace_Attrs
    { xs'whiteSpaceValue :: String
    } deriving (Eq,Show)
data Xs'pattern = Xs'pattern Xs'pattern_Attrs (Maybe Xs'annotation)
		deriving (Eq,Show)
data Xs'pattern_Attrs = Xs'pattern_Attrs
    { xs'patternValue :: String
    } deriving (Eq,Show)
data Xs'encoding = Xs'encoding Xs'encoding_Attrs
			       (Maybe Xs'annotation)
		 deriving (Eq,Show)
data Xs'encoding_Attrs = Xs'encoding_Attrs
    { xs'encodingValue :: String
    , xs'encodingFixed :: (Maybe Xs'encoding_fixed)
    } deriving (Eq,Show)
data Xs'encoding_fixed = Xs'encoding_fixed_true  | 
			 Xs'encoding_fixed_false
		       deriving (Eq,Show)
data Xs'period = Xs'period Xs'period_Attrs (Maybe Xs'annotation)
	       deriving (Eq,Show)
data Xs'period_Attrs = Xs'period_Attrs
    { xs'periodValue :: String
    , xs'periodFixed :: (Maybe Xs'period_fixed)
    } deriving (Eq,Show)
data Xs'period_fixed = Xs'period_fixed_true  | 
		       Xs'period_fixed_false
		     deriving (Eq,Show)
data Xs'duration = Xs'duration Xs'duration_Attrs
			       (Maybe Xs'annotation)
		 deriving (Eq,Show)
data Xs'duration_Attrs = Xs'duration_Attrs
    { xs'durationValue :: String
    , xs'durationFixed :: (Maybe Xs'duration_fixed)
    } deriving (Eq,Show)
data Xs'duration_fixed = Xs'duration_fixed_true  | 
			 Xs'duration_fixed_false
		       deriving (Eq,Show)
data Xs'schema = Xs'schema Xs'schema_Attrs
			   [(OneOf4 Xs'include Xs'import Xs'redefine Xs'annotation)]
			   [((OneOf7 Xs'simpleType Xs'complexType Xs'element Xs'attribute Xs'attributeGroup Xs'group Xs'notation),[(Xs'annotation)])]
	       deriving (Eq,Show)
data Xs'schema_Attrs = Xs'schema_Attrs
    { xs'schemaTargetNamespace :: (Maybe String)
    , xs'schemaVersion :: (Maybe String)
    , xs'schemaXmlns'xs :: (Defaultable String)
    , xs'schemaXmlns :: (Maybe String)
    , xs'schemaFinalDefault :: (Defaultable String)
    , xs'schemaBlockDefault :: (Defaultable String)
    , xs'schemaId :: (Maybe String)
    , xs'schemaElementFormDefault :: (Defaultable Xs'schema_elementFormDefault)
    , xs'schemaAttributeFormDefault :: (Defaultable Xs'schema_attributeFormDefault)
    , xs'schemaXml'lang :: (Maybe String)
    } deriving (Eq,Show)
data Xs'schema_elementFormDefault = Xs'schema_elementFormDefault_qualified
				     |  Xs'schema_elementFormDefault_unqualified
				  deriving (Eq,Show)
data Xs'schema_attributeFormDefault = Xs'schema_attributeFormDefault_qualified
				       |  Xs'schema_attributeFormDefault_unqualified
				    deriving (Eq,Show)
data Xs'complexType = Xs'complexType Xs'complexType_Attrs
				     (Maybe (Xs'annotation))
				     (OneOf3 Xs'simpleContent Xs'complexContent ((Maybe (OneOf4 Xs'all Xs'choice Xs'sequence Xs'group)),([(OneOf2 Xs'attribute Xs'attributeGroup)],(Maybe (Xs'anyAttribute)))))
		    deriving (Eq,Show)
data Xs'complexType_Attrs = Xs'complexType_Attrs
    { xs'complexTypeName :: (Maybe String)
    , xs'complexTypeId :: (Maybe String)
    , xs'complexTypeAbstract :: (Maybe Xs'complexType_abstract)
    , xs'complexTypeFinal :: (Maybe String)
    , xs'complexTypeBlock :: (Maybe String)
    , xs'complexTypeMixed :: (Defaultable Xs'complexType_mixed)
    } deriving (Eq,Show)
data Xs'complexType_abstract = Xs'complexType_abstract_true  | 
			       Xs'complexType_abstract_false
			     deriving (Eq,Show)
data Xs'complexType_mixed = Xs'complexType_mixed_true  | 
			    Xs'complexType_mixed_false
			  deriving (Eq,Show)
data Xs'complexContent = Xs'complexContent Xs'complexContent_Attrs
					   (Maybe (Xs'annotation))
					   (OneOf2 Xs'restriction Xs'extension)
		       deriving (Eq,Show)
data Xs'complexContent_Attrs = Xs'complexContent_Attrs
    { xs'complexContentMixed :: (Maybe Xs'complexContent_mixed)
    , xs'complexContentId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'complexContent_mixed = Xs'complexContent_mixed_true  | 
			       Xs'complexContent_mixed_false
			     deriving (Eq,Show)
data Xs'simpleContent = Xs'simpleContent Xs'simpleContent_Attrs
					 (Maybe (Xs'annotation))
					 (OneOf2 Xs'restriction Xs'extension)
		      deriving (Eq,Show)
data Xs'simpleContent_Attrs = Xs'simpleContent_Attrs
    { xs'simpleContentId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'extension = Xs'extension Xs'extension_Attrs
				 (Maybe (Xs'annotation))
				 (((Maybe (OneOf4 Xs'all Xs'choice Xs'sequence Xs'group)),([(OneOf2 Xs'attribute Xs'attributeGroup)],(Maybe (Xs'anyAttribute)))))
		  deriving (Eq,Show)
data Xs'extension_Attrs = Xs'extension_Attrs
    { xs'extensionBase :: String
    , xs'extensionId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'element = Xs'element Xs'element_Attrs
			     (Maybe (Xs'annotation))
			     (Maybe (OneOf2 Xs'complexType Xs'simpleType))
			     [(OneOf3 Xs'unique Xs'key Xs'keyref)]
		deriving (Eq,Show)
data Xs'element_Attrs = Xs'element_Attrs
    { xs'elementName :: (Maybe String)
    , xs'elementId :: (Maybe String)
    , xs'elementRef :: (Maybe String)
    , xs'elementType :: (Maybe String)
    , xs'elementMinOccurs :: (Maybe String)
    , xs'elementMaxOccurs :: (Maybe String)
    , xs'elementNillable :: (Maybe Xs'element_nillable)
    , xs'elementSubstitutionGroup :: (Maybe String)
    , xs'elementAbstract :: (Maybe Xs'element_abstract)
    , xs'elementFinal :: (Maybe String)
    , xs'elementBlock :: (Maybe String)
    , xs'elementDefault :: (Maybe String)
    , xs'elementFixed :: (Maybe String)
    , xs'elementForm :: (Maybe Xs'element_form)
    } deriving (Eq,Show)
data Xs'element_nillable = Xs'element_nillable_true  | 
			   Xs'element_nillable_false
			 deriving (Eq,Show)
data Xs'element_abstract = Xs'element_abstract_true  | 
			   Xs'element_abstract_false
			 deriving (Eq,Show)
data Xs'element_form = Xs'element_form_qualified  | 
		       Xs'element_form_unqualified
		     deriving (Eq,Show)
data Xs'group = Xs'group Xs'group_Attrs (Maybe (Xs'annotation))
			 (Maybe (OneOf3 Xs'all Xs'choice Xs'sequence))
	      deriving (Eq,Show)
data Xs'group_Attrs = Xs'group_Attrs
    { xs'groupName :: (Maybe String)
    , xs'groupRef :: (Maybe String)
    , xs'groupMinOccurs :: (Maybe String)
    , xs'groupMaxOccurs :: (Maybe String)
    , xs'groupId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'all = Xs'all Xs'all_Attrs (Maybe (Xs'annotation))
		     [(Xs'element)]
	    deriving (Eq,Show)
data Xs'all_Attrs = Xs'all_Attrs
    { xs'allMinOccurs :: (Maybe Xs'all_minOccurs)
    , xs'allMaxOccurs :: (Maybe Xs'all_maxOccurs)
    , xs'allId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'all_minOccurs = Xs'all_minOccurs_1
		      deriving (Eq,Show)
data Xs'all_maxOccurs = Xs'all_maxOccurs_1
		      deriving (Eq,Show)
data Xs'choice = Xs'choice Xs'choice_Attrs (Maybe (Xs'annotation))
			   [(OneOf5 Xs'element Xs'group Xs'choice Xs'sequence Xs'any)]
	       deriving (Eq,Show)
data Xs'choice_Attrs = Xs'choice_Attrs
    { xs'choiceMinOccurs :: (Maybe String)
    , xs'choiceMaxOccurs :: (Maybe String)
    , xs'choiceId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'sequence = Xs'sequence Xs'sequence_Attrs
			       (Maybe (Xs'annotation))
			       [(OneOf5 Xs'element Xs'group Xs'choice Xs'sequence Xs'any)]
		 deriving (Eq,Show)
data Xs'sequence_Attrs = Xs'sequence_Attrs
    { xs'sequenceMinOccurs :: (Maybe String)
    , xs'sequenceMaxOccurs :: (Maybe String)
    , xs'sequenceId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'any = Xs'any Xs'any_Attrs (Maybe Xs'annotation)
	    deriving (Eq,Show)
data Xs'any_Attrs = Xs'any_Attrs
    { xs'anyNamespace :: (Defaultable String)
    , xs'anyProcessContents :: (Defaultable Xs'any_processContents)
    , xs'anyMinOccurs :: (Defaultable String)
    , xs'anyMaxOccurs :: (Defaultable String)
    , xs'anyId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'any_processContents = Xs'any_processContents_skip  | 
			      Xs'any_processContents_lax  |  Xs'any_processContents_strict
			    deriving (Eq,Show)
data Xs'anyAttribute = Xs'anyAttribute Xs'anyAttribute_Attrs
				       (Maybe Xs'annotation)
		     deriving (Eq,Show)
data Xs'anyAttribute_Attrs = Xs'anyAttribute_Attrs
    { xs'anyAttributeNamespace :: (Defaultable String)
    , xs'anyAttributeProcessContents :: (Defaultable Xs'anyAttribute_processContents)
    , xs'anyAttributeId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'anyAttribute_processContents = Xs'anyAttribute_processContents_skip
				        |  Xs'anyAttribute_processContents_lax  | 
				       Xs'anyAttribute_processContents_strict
				     deriving (Eq,Show)
data Xs'attribute = Xs'attribute Xs'attribute_Attrs
				 (Maybe (Xs'annotation)) (Maybe (Xs'simpleType))
		  deriving (Eq,Show)
data Xs'attribute_Attrs = Xs'attribute_Attrs
    { xs'attributeName :: (Maybe String)
    , xs'attributeId :: (Maybe String)
    , xs'attributeRef :: (Maybe String)
    , xs'attributeType :: (Maybe String)
    , xs'attributeUse :: (Maybe Xs'attribute_use)
    , xs'attributeDefault :: (Maybe String)
    , xs'attributeFixed :: (Maybe String)
    , xs'attributeForm :: (Maybe Xs'attribute_form)
    } deriving (Eq,Show)
data Xs'attribute_use = Xs'attribute_use_prohibited  | 
			Xs'attribute_use_optional  |  Xs'attribute_use_required
		      deriving (Eq,Show)
data Xs'attribute_form = Xs'attribute_form_qualified  | 
			 Xs'attribute_form_unqualified
		       deriving (Eq,Show)
data Xs'attributeGroup = Xs'attributeGroup Xs'attributeGroup_Attrs
					   (Maybe (Xs'annotation))
					   [(OneOf2 Xs'attribute Xs'attributeGroup)]
					   (Maybe (Xs'anyAttribute))
		       deriving (Eq,Show)
data Xs'attributeGroup_Attrs = Xs'attributeGroup_Attrs
    { xs'attributeGroupName :: (Maybe String)
    , xs'attributeGroupId :: (Maybe String)
    , xs'attributeGroupRef :: (Maybe String)
    } deriving (Eq,Show)
data Xs'unique = Xs'unique Xs'unique_Attrs (Maybe (Xs'annotation))
			   Xs'selector (List1 (Xs'field))
	       deriving (Eq,Show)
data Xs'unique_Attrs = Xs'unique_Attrs
    { xs'uniqueName :: String
    , xs'uniqueId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'key = Xs'key Xs'key_Attrs (Maybe (Xs'annotation))
		     Xs'selector (List1 (Xs'field))
	    deriving (Eq,Show)
data Xs'key_Attrs = Xs'key_Attrs
    { xs'keyName :: String
    , xs'keyId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'keyref = Xs'keyref Xs'keyref_Attrs (Maybe (Xs'annotation))
			   Xs'selector (List1 (Xs'field))
	       deriving (Eq,Show)
data Xs'keyref_Attrs = Xs'keyref_Attrs
    { xs'keyrefName :: String
    , xs'keyrefRefer :: String
    , xs'keyrefId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'selector = Xs'selector Xs'selector_Attrs
			       (Maybe (Xs'annotation))
		 deriving (Eq,Show)
data Xs'selector_Attrs = Xs'selector_Attrs
    { xs'selectorXpath :: String
    , xs'selectorId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'field = Xs'field Xs'field_Attrs (Maybe (Xs'annotation))
	      deriving (Eq,Show)
data Xs'field_Attrs = Xs'field_Attrs
    { xs'fieldXpath :: String
    , xs'fieldId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'include = Xs'include Xs'include_Attrs (Maybe Xs'annotation)
		deriving (Eq,Show)
data Xs'include_Attrs = Xs'include_Attrs
    { xs'includeSchemaLocation :: String
    , xs'includeId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'import = Xs'import Xs'import_Attrs (Maybe Xs'annotation)
	       deriving (Eq,Show)
data Xs'import_Attrs = Xs'import_Attrs
    { xs'importNamespace :: (Maybe String)
    , xs'importSchemaLocation :: (Maybe String)
    , xs'importId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'redefine = Xs'redefine Xs'redefine_Attrs [Xs'redefine_]
		 deriving (Eq,Show)
data Xs'redefine_Attrs = Xs'redefine_Attrs
    { xs'redefineSchemaLocation :: String
    , xs'redefineId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'redefine_ = Xs'redefine_Xs'annotation Xs'annotation
		  | Xs'redefine_Xs'simpleType Xs'simpleType
		  | Xs'redefine_Xs'complexType Xs'complexType
		  | Xs'redefine_Xs'attributeGroup Xs'attributeGroup
		  | Xs'redefine_Xs'group Xs'group
		  deriving (Eq,Show)
data Xs'notation = Xs'notation Xs'notation_Attrs
			       (Maybe Xs'annotation)
		 deriving (Eq,Show)
data Xs'notation_Attrs = Xs'notation_Attrs
    { xs'notationName :: String
    , xs'notationId :: (Maybe String)
    , xs'notationPublic :: String
    , xs'notationSystem :: (Maybe String)
    } deriving (Eq,Show)
newtype Xs'annotation = Xs'annotation [Xs'annotation_] 		deriving (Eq,Show)
data Xs'annotation_ = Xs'annotation_Xs'appinfo Xs'appinfo
		    | Xs'annotation_Xs'documentation Xs'documentation
		    deriving (Eq,Show)
data Xs'appinfo = Xs'appinfo Xs'appinfo_Attrs ANYContent
		deriving (Eq,Show)
data Xs'appinfo_Attrs = Xs'appinfo_Attrs
    { xs'appinfoSource :: (Maybe String)
    , xs'appinfoId :: (Maybe String)
    } deriving (Eq,Show)
data Xs'documentation = Xs'documentation Xs'documentation_Attrs
					 ANYContent
		      deriving (Eq,Show)
data Xs'documentation_Attrs = Xs'documentation_Attrs
    { xs'documentationSource :: (Maybe String)
    , xs'documentationId :: (Maybe String)
    , xs'documentationXml'lang :: (Maybe String)
    } deriving (Eq,Show)


